﻿Public Class Form1
    ' Conversions.
    Private Const miles_per_km As Single = 0.6213712
    Private Const us_gallons_per_liter As Single = 0.264172047
    Private Const uk_gallons_per_liter As Single = 0.219969243

    ' Calculate the mileage statistics.
    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click
        ' Get the inputs.
        Dim miles As Single = Single.Parse(txtDistance.Text)
        Dim gallons As Single = Single.Parse(txtFuel.Text)

        ' Convert to miles and US gallons.
        If (radKilometers.Checked) Then miles *= miles_per_km
        If (radUkGallons.Checked) Then
            gallons *= us_gallons_per_liter / uk_gallons_per_liter
        ElseIf (radKilometers.Checked) Then
            gallons *= us_gallons_per_liter
        End If

        ' Calculate performance values.
        Dim us_mpg As Single = miles / gallons
        Dim us_gal_per_100_miles As Single = 100 / us_mpg

        ' US values.
        txtUsMpg.Text = us_mpg.ToString("0.00")
        txtUsGalPer100Miles.Text = us_gal_per_100_miles.ToString("0.00")

        ' UK values.
        Dim uk_gals As Single = gallons * uk_gallons_per_liter / us_gallons_per_liter
        Dim uk_mpg As Single = miles / uk_gals
        Dim uk_gal_per_100_miles As Single = 100 / uk_mpg
        txtUkMpg.Text = uk_mpg.ToString("0.00")
        txtUkGalPer100Miles.Text = uk_gal_per_100_miles.ToString("0.00")

        ' Metric values.
        Dim liters As Single = gallons / us_gallons_per_liter
        Dim kilometers As Single = miles / miles_per_km
        Dim km_per_liter As Single = kilometers / liters
        Dim l_per_100_km As Single = 100 / km_per_liter
        txtKpl.Text = km_per_liter.ToString("0.00")
        txtLiterPer100km.Text = l_per_100_km.ToString("0.00")
    End Sub
End Class
